import { 
    select,
    range,
    event,
    zoom,
    min,
    scaleOrdinal,
    scaleSqrt
  } from 'd3';

import { BuildTiles} from './BuildTiles'

  const svgWidth = 600;
	const svgHeight = 300;
	
  const svg = select('svg')
      .attr('width', svgWidth)
      .attr('height', svgHeight)
      .style('border', 'blue solid')  
  
  const nLevel     = 8;
	const nCol       = 4; 
	const nLine      = 5;
  const nBalls     = 16;
	const stepMargin = 5;
  const incr       = 0.5;

	const step = min([svgWidth/nCol,svgHeight/nLine]); //	console.log("Here is the step : " + step);

	const Level = range(1,nLevel+1); //console.log("Level : " + Level);
  
  
//Array of ray for each level : 
	const ray0 = step/2-stepMargin; console.log("Ray0 is : " + ray0)
  var ray = [ray0];  console.log("ray is : " + ray)   
  for (var i in Level){ray.push(ray0*(incr**Level[i]))}  // console.log("The ray table + " + ray)
	document.getElementById('')


  const xPosition = d =>  (d%nCol) * step + step/2;
  const yPosition = d =>  step/2+(Math.floor(d/nCol))*step;
  
  const dataPoint = {id : range(nBalls)} ; console.log("dataPoint.id is : " + dataPoint.id) 
  

  


  const g = select('svg').append('g').attr('transform', (d) => `translate(${0}, ${10})`);
  g.call(BuildTiles,{
    	dataPoint,
      step, 
      nCol,
  		stepMargin})         
	
          
  const circlesG = g.selectAll('g').data(dataPoint.id).enter()
  
  circlesG.append('circle')
          .attr('class', 'circleEntities')
          .attr('cx', svgWidth/2)
          .attr('cy', svgHeight/2)
          .attr('r', 0)
          .attr('fill', 'DarkBlue')
                      .transition().duration(2000)
                      .attr('cx', d => xPosition(d))
                      .attr('cy', d => yPosition(d))
                      .attr('r', ray[0]);
      
  circlesG.append('circle')
              .attr('cx', 0)
              .attr('cy', d => yPosition(d))
              .attr('r', 0)
              .attr('fill', 'RoyalBlue')
 							.transition().duration(2000)
                      .attr('cx', d => xPosition(d))
                      .attr('r', ray[1]);
   
  circlesG.append('circle')
              .attr('cx', d => xPosition(d))
              .attr('cy', d => yPosition(d))
              .attr('r', ray[2])
              .attr('fill', 'darkblue')    
  
  circlesG.append('circle')
              .attr('cx', d => xPosition(d))
              .attr('cy', d => yPosition(d))
              .attr('r', ray[3])
              .attr('fill', 'white')
  
  circlesG.append('circle')
              .attr('cx', d => xPosition(d))
              .attr('cy', d => yPosition(d))
              .attr('r', ray[4])
              .attr('fill', 'lightBlue')
    			.append('title')
        			.text(d => "hello")	



 circlesG.append('circle')
              .attr('cx', d => xPosition(d) + Math.cos(40*Math.PI/180)*(ray[4]+ray[3]))
              .attr('cy', d => yPosition(d) - Math.sin(40*Math.PI/180)*(ray[4]+ray[3]))
              .attr('r', ray[5])
              .attr('fill', 'yellow')    
  
  circlesG.append('circle')
              .attr('cx', d => xPosition(d) + Math.cos(26*Math.PI/180)*(ray[4]+ray[2]))
              .attr('cy', d => yPosition(d) - Math.sin(26*Math.PI/180)*(ray[4]+ray[2]))
              .attr('r', ray[5])
              .attr('fill', 'lightgreen') 
  
svg.call(zoom().on('zoom', () => {
g.attr('transform', event.transform);
}));
               
                         
  // g.selectAll('path.vertical') // selection
  // 		.data(range(nCol+1))		// data join
  //   	.enter()										// Enter-Update-Exit
  //       .append('path')
  //       .attr('class', 'vertical')
  //       .attr('d', d => `M${d * 100} 0 V300`);
  
  // g.selectAll('path.horizontal')
  //     .data(range(nLine+1))
  //     .enter()
  //   		.append('path')
  //     	.attr('class', 'horizontal')
  //     	.attr('d', d => `M0 ${d * 100} H700`);


  
  // g.selectAll('rect')
  //     .data(range(nBalls))
  //     .enter().append('rect')
  //     .attr('class', 'rectEntities2')
  //     .attr('x', d => (d%7) * 100 + 30)
  // 		.attr('y', d => (d%3) * 100 + 30)
  // 		.attr('width', 40)
  // 		.attr('height', 40)
  // 		.attr('fill', 'yellow');
  
  
  
  
  // const myVerticals2 = svg2
  // 		.selectAll('path.vertical') // selection
  // 		.data(range(nCol+1))		// data join
  //   	.enter()										// Enter-Update-Exit
  //       .append('path')
  //       .attr('class', 'vertical')
  //       .attr('d', d => `M${d * 100/nCol+1} 0 V100`);
  
  // svg2.selectAll('path.horizontal')
  //     .data(range(nLine+1))
  //     .enter().append('path')
  //     .attr('class', 'horizontal')
  //     .attr('d', d => `M0 ${d * 100/nLine+1} H100`);
  